#pragma once

#include <string.h>
#include <stddef.h>
#include <stdint.h>

#ifdef barrier
#  undef barrier
#endif
#define barrier() asm volatile("": : :"memory")

extern uint32_t charcrandom_u32(void);
extern uint64_t charcrandom_u64(void);
extern void charcrandom_stir(void);
extern void charcrandom_addrandom(uint8_t *dat, size_t datlen);
extern void charcrandom_buf(void *buf, size_t n);
extern uint32_t charcrandom_uniform32(uint32_t upper_bound);
extern uint64_t charcrandom_uniform64(uint64_t upper_bound);
static inline void* secure_memset(void* p, size_t n)
{
    void* retp = memset(p, 0, n);
    barrier();
    return retp;
}

